package org.sonar.plugins.findbugs.xml;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.annotations.*;

import java.util.*;

@XStreamAlias("FindBugsFilter")
public class FindBugsModuleTree {

  @XStreamImplicit
  private List<Match> matchs;

  public static FindBugsModuleTree fromXml(String xml) {
    XStream xstream = createXStream();
    return (FindBugsModuleTree) xstream.fromXML(xml);
  }

  public FindBugsModuleTree() {
    matchs = new ArrayList<Match>();
  }

  public String toXml() {
    XStream xstream = createXStream();
    return xstream.toXML(this);
  }

  public List<Match> getMatchs() {
    return matchs;
  }

  public void setMatchs(List<Match> matchs) {
    this.matchs = matchs;
  }

  public void addMatch(Match child) {
    matchs.add(child);
  }

  public int getMatchPosition(String nameToFind) {
    int i = 0;
    for (Match child : matchs) {
      if (child.getBug().getPattern().equals(nameToFind)) {
        return i;
      }
      i++;
    }
    return -1;
  }

  private static XStream createXStream() {
    XStream xstream = new XStream();
    xstream.processAnnotations(FindBugsModuleTree.class);
    xstream.processAnnotations(Match.class);
    xstream.processAnnotations(Bug.class);
    return xstream;
  }

}
