/*
 * Sonar, entreprise quality control tool.
 * Copyright (C) 2007-2008 Hortis-GRC SA
 * mailto:be_agile HAT hortis DOT ch
 *
 * Sonar is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * Sonar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sonar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package org.sonar.plugins.findbugs.xml;

import ch.hortis.sonar.model.ActiveRule;
import org.sonar.plugins.findbugs.FindbugsPlugin;

import java.util.*;

public class ModuleTreeBuilder {
  private final List<ActiveRule> activeRules;

  public ModuleTreeBuilder(List<ActiveRule> activeRules) {
    this.activeRules = new ArrayList<ActiveRule>(activeRules);
  }

  public FindBugsModuleTree build() {
    FindBugsModuleTree root = new FindBugsModuleTree();
    for (ActiveRule activeRule : activeRules) {
      if (FindbugsPlugin.KEY.equals(activeRule.getPluginName())) {
        Match child = createChild(activeRule);
        root.addMatch(child);
      }
    }
    return root;
  }

  private static Match createChild(ActiveRule activeRule) {
    Bug bug = new Bug(activeRule.getConfigKey());
    Match child = new Match();
    child.setBug(bug);
    return child;
  }
}
